// C++ 11
#include <bits/stdc++.h>
using namespace std;
// function to find all the matches
map<string, string> json2Map(string jsonData) {
    map<string, string> dataMap;
    string regExspr("\\\"(\\w+)\\\":\\s*(\\\"([^\"]*)\\\"|(([+-]?\\d*)(\\.\\d+)?))");
    regex re(regExspr);
    for (sregex_iterator it = sregex_iterator(jsonData.begin(), jsonData.end(), re);it != sregex_iterator(); it++) {
            smatch match;
            match = *it;
            int indexValue = 3;
            if (match.str(3) == "") indexValue = 2;
            cout << match.str(1) << "\t" << match.str(indexValue) << endl;
            dataMap[match.str(1)] =  match.str(indexValue);
    }
    return dataMap;
}
int main( int numberArgs, char* argsList[] ) {
    vector<string> params{ "fGen.tcl","T,t1;N,n1", "", "" };
    int commandLength = 40; // roughly default + fixed (i.e. tclsh ... >j.json)
    for (int i=1; i<numberArgs; i++) {
        params[i-1] = argsList[i];
        commandLength += strlen(params[i-1].c_str());
    }
    char tcl[commandLength];
    sprintf (tcl, "tclsh %s %s %s %s > j.json", params[0].c_str(), params[1].c_str(),params[2].c_str(),params[3].c_str());
    int status = system(tcl);
    ifstream jsonFile("j.json");
    string jsonData {istreambuf_iterator<char>(jsonFile), istreambuf_iterator<char>()};
    cout << jsonData << endl;
    map<string, string> dataMap = json2Map(jsonData);
    if (dataMap.count("Integer") > 0) {
        cout << "Sum: " << (atof(dataMap["Integer"].c_str()) + atof(dataMap["Number"].c_str()) + atof(dataMap["DecNumber"].c_str())) << endl;
    }
	return 0;
}
