# TK SandBox Formgen
# Vesion 0.0.5 18 September 2019
# -----------------------------------
proc infoMail {button} {
	tk_messageBox -message "Password almost 6 characters" -type ok -icon info
}
proc handle {e} {
	global examplesMap	
	lassign $e event path name
	if {$event == "Start"} {
		fg_setCombo Theme "[join [ttk::style theme names] "|"]"
	}
#	puts "$event $path $name"
	if {$name == "Form" && $event == "Select"} {
		if {[valueOf $name] != ""} {setValue try "[dict get $examplesMap [valueOf $name]]"}
#		setValue try "[dict get $examplesMap $value]"
	}
}
proc cBack2 {data} {
	foreach id [dict keys $data] {puts "$id\t : [dict get $data $id]"}
	exit
}
proc cBack {data} {
	global examplesMap
	# [getDictValue $data "Theme" ""]
	if {[dict get $data "fg_Button"] == "Cancel"} {exit}
	set prefix "Title,Form example of [dict get $data "Form"];Ground,[getDictValue $data "Ground" ""],[getDictValue $data "Theme" ""];Labels,Right, :;"
#	foreach id [dict keys $data] {puts "$id\t : [dict get $data $id]"}
	set callParameter "cBack2"
	if {[dict get $data "FileType"] != ""} {
		append file [expr {[dict get $data "File"] == "" ? "data" : [dict get $data "File"]}] "." [dict get $data "FileType"]
		set callParameter $file
	}	
	if {[dict get $data "fg_Button"] == "execButton"} {
		set p "$prefix[dict get $data "try"]"
	} else {
		set p "Title,Example of form;"
		append p "Ground,[dict get $data "Ground"],[dict get $data "Theme"];"
		append p "Text,Text;"
		append p "P,psw,Password,,Almost 6 characters;"
		append p "T,Mail,E mail,18;"
		append p "N,Number;"
		append p "IN,iNumber,Integer Number;"
		append p "DN,dNumber,Decimal Number;"
		append p "Defaults,Text:Text,psw:Lafayette,ckBox:1,greeck:Beta,iNumber:17,dNumber:-3.1415,Gender:F;"
		append p "Default,Scale:90,Scale2:-0.2;"
		append p "RDB,Gender,,,M:Male|F:Female|U:Unspecified;"
		append p "CMB,greeck,Greek letters,,A:Alfa|Beta|G:Gamma|Delta;"
		append p "CMT,spinBox,Combo and text,,A:Alfa|Delta|G:Gamma|Omega|T:Tau;"
		append p "Check,ckBox,Check box,,Accept news;"
		append p "Check,ckBox2,Check box2,,Agree;"
		append p "Scale,Scale,Scale;"
		append p "Scale,Scale2,Scale 2,,1 -1;"
		append p "QS,Urgency,,,White|Green|Yellow|Red;"
		append p "Time,Time;"
		append p "Labels,Right, :;"
		append p "Req,Number;"
		append p "Validate,Mail Is mail,Incorrect mail form;"
		append p "Validate,psw is .{6#2c},Password too short;"
		append p "B,confirmButton,\u2714,,fg_Exit;"
		append p "B,infoButton,img/info.png,,infoMail;"
		append p "After,confirmButton,Mail;"
		append p "After,infoButton,psw;"
		append p "File,File,,40,Image Files:*.gif *.jpg,Text Script:*.tcl,All: *;"
		set systemTime [clock seconds]
		append p "H,hField,[clock format $systemTime];"
	}
	formGen [list $p $callParameter]
}
set examplesMap [dict create "T" "Text,Text;P,psw,Password,,Almost 6 characters;T,Mail,E mail,18;N,Number;IN,iNumber,Integer Number;\
								DN,dNumber,Decimal Number;A,textArea,Text area,5;" \
							 "S" "CMB,greeck,Greek letters,,A:Alfa|Beta|G:Gamma|Delta;CMT,spinBox,Combo and text,,A:Alfa|Delta|G:Gamma|Omega|T:Tau;\
								 Scale,Scale2,Scale 2,222,1 -1;QS,Urgency,,,White|Green|Yellow|Red;Default,Scale2:-0.35,Urgency:Yellow" \
							 "B" "T,Mail,E mail,18;RDB,Gender,,,M:Male|F:Female|U:Unspecified;B,infoButton,\u24d8,,infoMail;After,infoButton,Mail;\
							     B,Start,\u270E;B,fg_Cancel,\u2718;B,fg_Reset,\u21B6;"\
							 "C" "CMB,greeck,Greek letters,,A:Alfa|Beta|G:Gamma|Delta;CMT,spinBox,Combo and text,,A:Alfa|Delta|G:Gamma|Omega|T:Tau;"\
							 "F" "File,File,,40,Images:*.gif *.jpg *.png,All:*;Default,File:C:\\www\\condorinformatique\\nodejs\\tcl;D,Folder,,30;WF,wFile,Write File;"]
append folder [file dirname [file normalize [info script ]]] "/"
append src $folder "fGen.tcl"
source $src
# ::tk::icons::information ::tk::icons::error ::tk::icons::warning ::tk::icons::question
set ask "Title,Form generalities;Ground,silver;"
append ask "CMB,Theme,,,|alt|clam|classic|default|vista|winnative|xpnative;"
append ask "CMB,Ground,,,|cyan|gray|magenta|olive|silver|teal;"
append ask "CMB,Form,Form type,,|T:Texts|B:Buttons|C:Combo boxes|F:Files and folders|S:Scales and combos;"
append ask "T,File,File name;"
append ask "RDB,FileType,,,json:Json|txt:Text;"
append ask "T,try,Try this,400;"
append ask "After,FileType,File;"
append ask "Default,Theme:clam,Ground:teal,File:j,Form:Texts;"
append ask "B,execButton,\u270E;"	; # img/see.png \u270E
append ask "After,execButton,try;"
formGen [list $ask cBack handle]
#foreach id [dict keys $answer] {puts "$id\t : [dict get $answer $id]"}
