const args = process.argv.slice(2)
const {exec} = require('child_process');
var command = 'tclsh ' + args[0] + ' "' + args[1] + '" ' + args[2] + ' "' + args[3]
const tcl = exec(command, function (error, stdout, stderr) {
	if (error) {    
		console.error(`exec error: ${error}`);
		return;
	}
	console.log('Child Process STDOUT: '+stdout); 
});
let jsonData = '';
tcl.stdout.on('data', (chunk) => {
  jsonData += chunk.toString();
});
tcl.on('exit', () => {
	console.log(jsonData);
	var data = JSON.parse(jsonData)	// the data becomes a JavaScript object 
	if ("Integer" in data) {
			console.log("Sum " + (data.Integer + data.Number + data.DecNumber))
	}
});