namespace eval handler {
	variable examplesMap [dict create "Texts" "Text,Text;P,psw,Password,,Almost 6 characters;T,Mail,E mail,18;N,Number;IN,Integer,Integer Number;\
								DN,DecNumber,Decimal Number;A,textArea,Text area,5;;Default,Mail:ross@lib.it,Integer:7,Number:-11,DecNumber:3.1415;" \
							 "Scales and Check box" "CMB,greeck,Greek letters,,A:Alfa|Beta|G:Gamma|Delta;CMT,spinBox,Combo and text,,A:Alfa|Delta|G:Gamma|Omega|T:Tau;\
								 Scale,Scale2,Scale 2,222,1 -1;QS,Urgency,,,White|Green|Yellow|Red;Default,Scale2:-0.35,Urgency:Yellow,ckBox:1; \
								 Check,ckBox,Check box,,Accept news;Check,ckBox2,Check box2,,Agree;" \
							 "Buttons" "P,psw,Password,18;RDB,Gender,,,M:Male|F:Female|U:Unspecified;B,infoButton,\u24d8,,infoPsw;After,infoButton,psw;\
							     B,Start,\u270E;B,fg_Cancel,\u2718;B,fg_Reset,\u21B6;Default,Gender:M;Required,psw;Validate,psw is .{6#2c},Password too short;\
								 RDB,Langue,,,us:img\\uss.png|fr:img\\frs.png;"\
							 "Combo boxes" "CMB,greeck,Greek letters,,A:Alfa|Beta|G:Gamma|Delta;CMT,spinBox,Combo and text,,A:Alfa|Delta|G:Gamma|Omega|T:Tau;"\
							 "Files and folders" "File,File,,40,Images:*.gif *.jpg *.png,All:*;Default,File:C:\\www\\condorinformatique\\nodejs\\tcl;D,Folder,,30;WF,wFile,Write File;"]
}
proc handle {e} {
	lassign $e event path name
	if {$event == "Start"} {
		fg_setCombo Theme "[join [ttk::style theme names] "|"]"
	}
	if {$name == "Form" && $event == "Select"} {
		if {[valueOf $name] != ""} {setValue try "[dict get $::handler::examplesMap [valueOf $name]]"}
	}
}
proc infoPsw {button} {
	tk_messageBox -message "Password almost 6 characters" -type ok -icon info
}
proc tryForm {data} {
	append prefix "Title,Form example of " [dict get $data "Form"] ";Ground," [dict get $data "Ground"] "," [dict get $data "Theme"] ";Labels,Right, :;"
	set systemTime [clock seconds]
	append prefix "H,hField,[clock format $systemTime];" [dict get $data "try"]
	formGen [list "$prefix"]
}
